searchNodes=[{"doc":"This check has a base priority of high and works with any version of Elixir. Explanation Checks if database migrations contain potentially dangerous operations. Configuration parameters There are no specific parameters for this check. Like with all checks, general params can be applied. Parameters can be configured via the .credo.exs config file .","ref":"ExcellentMigrations.CredoCheck.MigrationsSafety.html","title":"ExcellentMigrations.CredoCheck.MigrationsSafety","type":"module"},{"doc":"This module finds potentially dangerous or destructive database operations in a given migration AST.","ref":"ExcellentMigrations.DangersDetector.html","title":"ExcellentMigrations.DangersDetector","type":"module"},{"doc":"Traverses ast and finds potentially dangerous database operations. Returns keyword list containing danger types and lines where they were detected. Parameters ast is a structure that represents AST of database migration. It can be obtained e.g. via Code.string_to_quoted!/1 . Examples iex&gt; ast = Code . string_to_quoted! ( &quot;&quot;&quot; ...&gt; alter table(&quot;dumplings&quot;) do ...&gt; remove(:taste, :string) ...&gt; remove(:stuffing, :string) ...&gt; end ...&gt; &quot;&quot;&quot; ) { :ok , { :alter , [ line : 1 ] , [ { :table , [ line : 1 ] , [ &quot;dumplings&quot; ] } , [ do : { :__block__ , [ ] , [ { :remove , [ line : 2 ] , [ :taste , :string ] } , { :remove , [ line : 3 ] , [ :stuffing , :string ] } ] } ] ] } } iex&gt; ExcellentMigrations.DangersDetector . detect_dangers ( ast ) [ column_removed : 2 , column_removed : 3 ]","ref":"ExcellentMigrations.DangersDetector.html#detect_dangers/1","title":"ExcellentMigrations.DangersDetector.detect_dangers/1","type":"function"},{"doc":"","ref":"ExcellentMigrations.DangersDetector.html#t:ast/0","title":"ExcellentMigrations.DangersDetector.ast/0","type":"type"},{"doc":"","ref":"ExcellentMigrations.DangersDetector.html#t:danger_type/0","title":"ExcellentMigrations.DangersDetector.danger_type/0","type":"type"},{"doc":"","ref":"ExcellentMigrations.DangersDetector.html#t:line/0","title":"ExcellentMigrations.DangersDetector.line/0","type":"type"},{"doc":"This module finds migration files in a project and detects potentially dangerous database operations in them.","ref":"ExcellentMigrations.Runner.html","title":"ExcellentMigrations.Runner","type":"module"},{"doc":"Detects potentially dangerous database operations in database migration files. Options :migrations_paths - optional list of file paths to be checked. Scope of analysis If migrations_paths are specified, the analysis will be narrowed down to these files only. If not and application env :excellent_migrations, :start_after is set, only migrations with timestamp older than the provided one will be chosen. If none of the above, all migration files in a project will be analyzed.","ref":"ExcellentMigrations.Runner.html#check_migrations/1","title":"ExcellentMigrations.Runner.check_migrations/1","type":"function"},{"doc":"","ref":"ExcellentMigrations.Runner.html#t:danger/0","title":"ExcellentMigrations.Runner.danger/0","type":"type"},{"doc":"","ref":"ExcellentMigrations.Runner.html#t:danger_type/0","title":"ExcellentMigrations.Runner.danger_type/0","type":"type"},{"doc":"Runs analysis on database migration files and detects potentially dangerous operations.","ref":"Mix.Tasks.ExcellentMigrations.CheckSafety.html","title":"Mix.Tasks.ExcellentMigrations.CheckSafety","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.ExcellentMigrations.CheckSafety.html#run/1","title":"Mix.Tasks.ExcellentMigrations.CheckSafety.run/1","type":"function"},{"doc":"Runs ecto.migrate task only if no dangerous operations were detected in migrations.","ref":"Mix.Tasks.ExcellentMigrations.Migrate.html","title":"Mix.Tasks.ExcellentMigrations.Migrate","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.ExcellentMigrations.Migrate.html#run/1","title":"Mix.Tasks.ExcellentMigrations.Migrate.run/1","type":"function"},{"doc":"Detect potentially dangerous or destructive operations in your database migrations.","ref":"readme.html","title":"Excellent Migrations","type":"extras"},{"doc":"The package can be installed by adding excellent_migrations to your list of dependencies in mix.exs : def deps do [ { :excellent_migrations , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"Excellent Migrations - Installation","type":"extras"},{"doc":"This tool analyzes code (AST) of migration files. You don't have to edit or include anything in your migration files, except for ocassionally adding module attribute @safety_assured .","ref":"readme.html#how-it-works","title":"Excellent Migrations - How It Works","type":"extras"},{"doc":"There are multiple ways to integrate with Excellent Migrations. mix task mix excellent_migrations.check_safety This mix task analyzes migrations and logs a warning for each danger detected. migration task mix excellent_migrations.migrate Running this task will first analyze migrations. If no dangers are detected it will proceed and run mix ecto.migrate . If there are any, it will log errors and stop. Credo check Excellent Migrations provide custom check for Credo . Add ExcellentMigrations.CredoCheck.MigrationsSafety to your .credo file. Example warnings: Warnings - please take a look ┃ ┃ [ W ] ↗ Raw SQL used ┃ apps / cookbook / priv / repo / migrations / 20211024133700 _create_recipes . exs : 13 #(Cookbook.Repo.Migrations.CreateRecipes.up) ┃ [ W ] ↗ Index added not concurrently ┃ apps / cookbook / priv / repo / migrations / 20211024133705 _create_index_on_veggies . exs : 37 #(Cookbook.Repo.Migrations.CreateIndexOnVeggies.up) Code You can also use it in code. To do so, you need to get AST of your migration, e.g. via Code.string_to_quoted/2 and pass it to ExcellentMigrations.DangersDetector.detect_dangers(ast) . It will return keyword list containing danger types and lines where they were detected.","ref":"readme.html#how-to-use-it","title":"Excellent Migrations - How to use it","type":"extras"},{"doc":"Potentially dangerous operations: Adding a check constraint Adding a column with a default value Backfilling data Changing the type of a column Executing SQL directly Removing a column Renaming a column Renaming a table Setting NOT NULL on an existing column Postgres-specific checks: Adding a json column Adding a reference Adding an index non-concurrently Best practices: Keeping non-unique indexes to three columns or less You can also disable specific checks . Removing a column Example defmodule Cookbook.RemoveSizeFromDumplings do def change do alter table ( :dumplings ) do remove :size , :string end end end Adding a column with a default value Example defmodule Cookbook.AddTasteToDumplingsWithDefault do def change do alter table ( :dumplings ) do add ( :taste , :string , default : &quot;sweet&quot; ) end end end Backfilling data Example defmodule Cookbook.BackfillRecords do def change do Repo . insert! ( % Dumpling { taste : &quot;umami&quot; } ) end end Changing the type of a column Example defmodule Cookbook.ChangeColumnSizeTypeToInteger do def change do alter table ( :dumplings ) do modify ( :size , :integer ) end end end Renaming a column Example defmodule Cookbook.RenameFillingToStuffing do def change do rename table ( :dumplings ) , :filling , to : :stuffing end end Renaming a table Example defmodule Cookbook.RenameDumplingsToNoodles do def change do rename ( table ( :dumplings ) , to : table ( &quot;noodles&quot; ) ) end end Adding a check constraint Example defmodule Cookbook.CreatePriceConstraint do def change do create constraint ( &quot;dumplings&quot; , :price_must_be_positive , check : &quot;price &gt; 0&quot; ) end end Setting NOT NULL on an existing column Example defmodule Cookbook.AddNotNullOnShape do def change do alter table ( :dumplings ) do modify :shape , :integer , null : true end end end Executing SQL directly Example defmodule Cookbook.CreateIndexOnDumplings do def up do execute ( &quot;CREATE INDEX dumplings_geog ON dumplings using GIST(Geography(geom));&quot; ) end def down do execute ( &quot;DROP INDEX dumplings_geog;&quot; ) end end Adding an index non-concurrently Example defmodule Cookbook.AddIndex do def change do create index ( :dumplings , [ :recipe_id , :flour_id ] ) end end Adding a reference Example defmodule Cookbook.AddReferenceToIngredient do def change do alter table ( :recipes ) do modify :ingredient_id , references ( :ingredients ) end end end Adding a json column defmodule Cookbook.AddDetailsJson do def change do add :details , :json , default : &quot;{}&quot; end end Keeping non-unique indexes to three columns or less defmodule Cookbook.AddIndexOnIngredients do def change do alter table ( :dumplings ) do create index ( :ingredients , [ :a , :b , :c , :d ] , concurrently : true ) end end end","ref":"readme.html#checks","title":"Excellent Migrations - Checks","type":"extras"},{"doc":"To mark an operation in a migration as safe list it in @safety_assured attribute. It will be ignored during analysis. defmodule Cookbook.AddTasteToDumplingsWithDefault do @safety_assured [ :column_added_with_default ] def change do alter table ( :dumplings ) do add ( :taste , :string , default : &quot;sweet&quot; ) end create index ( :dumplings , [ :recipe_id , :flour_id ] ) end end You can also mark all operations as safe in a given migration by adding @safety_assured :all defmodule Cookbook.BackfillRecords do @safety_assured :all def change do Repo . insert! ( % Dumpling { taste : &quot;umami&quot; } ) end end Possible operation types are: :column_added_with_default :column_removed :column_renamed :column_type_changed :index_not_concurrently :many_columns_index :not_null_added :operation_delete :operation_insert :operation_update :raw_sql_executed :table_renamed","ref":"readme.html#assuring-safety","title":"Excellent Migrations - Assuring safety","type":"extras"},{"doc":"Ignore specific dangers for all migraion checks with: config :excellent_migrations , skip_checks : [ :raw_sql_executed , :not_null_added ]","ref":"readme.html#disable-checks","title":"Excellent Migrations - Disable checks","type":"extras"},{"doc":"To skip analyzing migrations that were created before adding this package, set timestamp from the last migration in start_after in config: config :excellent_migrations , start_after : &quot;20191026080101&quot;","ref":"readme.html#existing-migrations","title":"Excellent Migrations - Existing migrations","type":"extras"},{"doc":"https://github.com/ankane/strong_migrations (Ruby) https://github.com/rrrene/credo (Elixir)","ref":"readme.html#similar-tools","title":"Excellent Migrations - Similar tools","type":"extras"},{"doc":"Everyone is encouraged to help improve this project. Here are a few ways you can help: Give feedback – your opinion matters Suggest or add new features, submit pull requests Report bugs Improve documentation","ref":"readme.html#contributing","title":"Excellent Migrations - Contributing","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"Fixed Fixed handling index with one column as an atom","ref":"changelog.html#0-1-1-2021-11-19","title":"Changelog - 0.1.1 - 2021-11-19","type":"extras"},{"doc":"Added First release!","ref":"changelog.html#0-1-0-2021-11-18","title":"Changelog - 0.1.0 - 2021-11-18","type":"extras"}]